package com.puppy.uhfexample;

import android.annotation.SuppressLint;
import android.app.Application;
import android.bluetooth.BluetoothDevice;
import android.content.pm.ApplicationInfo;
import android.media.AudioManager;
import android.media.SoundPool;

import com.puppy.uhf.UHFManager;
import com.puppy.uhfexample.base.BaseFragment;
import com.puppy.uhfexample.util.MLog;
import com.tencent.mmkv.MMKV;

import java.util.List;

/**
 * @author cyd
 */
public class MyApp extends Application {

    public static byte[] UHF = {0x01, 0x02, 0x03};
    //  public static boolean ifOpenFan = false;
    public static boolean ifOpenSound = false; //是否启动盘点声音
    //  public static AlertDialog showAtd = null;//应用是否处于弹框状态
    public static int currentInventoryDataType = -1;
    private SoundPool soundPool;
    private int soundID;
    /**
     * false默认走盘点，true走pda扫描功能；UD01把枪的Switch按键用来切换是盘点还是扫描
     */
    public static boolean ifInventoryOrScan = false;
    /**
     * 是否已连接蓝牙
     */
    public static boolean ifConnectBlue = false;
    private static MyApp myApp;
    private UHFManager uhfManager;
    private List<BaseFragment> mainFragmentsList;
    private List<BaseFragment> tagsFragmentsList;
    private List<BaseFragment> settingsFragmentsList;

    private BluetoothDevice connectedDevice;
    public static boolean ifUpdateFirmwareOrInventory = false;
    private  BaseFragment currentTabFragment;

    public BaseFragment getCurrentTabFragment() {
        return currentTabFragment;
    }

    public void setCurrentTabFragment(BaseFragment currentTabFragment) {
        this.currentTabFragment = currentTabFragment;
    }

    public BluetoothDevice getConnectedDevice() {
        return connectedDevice;
    }

    public void setConnectedDevice(BluetoothDevice connectedDevice) {
        this.connectedDevice = connectedDevice;
    }

    public static MyApp getMyApp() {
        return myApp;
    }

    public void setUHFManager(UHFManager uhfManager) {
        this.uhfManager = uhfManager;
    }


    public UHFManager getUHFManager() {
        return uhfManager;
    }

    @SuppressLint("WrongConstant")
    @Override
    public void onCreate() {
        super.onCreate();
        myApp = this;
        MLog.ifShown = isApkInDebug();
        String rootDir = MMKV.initialize(this);
        MLog.e("mmkv dir = " + rootDir);
//        Thread.setDefaultUncaughtExceptionHandler(new CrashHandler());
        soundPool = new SoundPool(10, AudioManager.STREAM_SYSTEM, 5);
        soundID = soundPool.load(this, R.raw.beep, 1);
    }


    public List<BaseFragment> getMainFragmentsList() {
        return mainFragmentsList;
    }

    public void setMainFragmentsList(List<BaseFragment> mainFragmentsList) {
        this.mainFragmentsList = mainFragmentsList;
    }

    public List<BaseFragment> getTagsFragmentsList() {
        return tagsFragmentsList;
    }

    public void setTagsFragmentsList(List<BaseFragment> tagsFragmentsList) {
        this.tagsFragmentsList = tagsFragmentsList;
    }

    public List<BaseFragment> getSettingsFragmentsList() {
        return settingsFragmentsList;
    }

    public void setSettingsFragmentsList(List<BaseFragment> settingsFragmentsList) {
        this.settingsFragmentsList = settingsFragmentsList;
    }

    //播放滴滴滴的声音
    public void playSound() {
        soundPool.play(soundID, 1, 1, 0, 1, 1);
    }

    //判断当前应用是否是debug状态
    private boolean isApkInDebug() {
        try {
            ApplicationInfo info = getApplicationInfo();
            return (info.flags & ApplicationInfo.FLAG_DEBUGGABLE) != 0;
        } catch (Exception e) {
            return false;
        }
    }


}
