package com.puppy.uhfexample.base;


import com.puppy.uhfexample.R;
import com.puppy.uhfexample.util.MUtil;
import com.permissionx.guolindev.PermissionX;

import java.util.ArrayList;
import java.util.List;

import androidx.appcompat.app.AppCompatActivity;

public class BaseActivity extends AppCompatActivity {


    public void reqPermissions(String... permissions) {
        List<String> needPermission = getNeedRequestPermission(permissions);
        if (needPermission.size() <= 0)
            return;
        String[] realNeedRequestPermission = needPermission.toArray(new String[0]);
        String perReqPermissionNotice = getString(R.string.the_pm_required_notice);
        String userConsent = getString(R.string.i_understand);
        PermissionX.init(this)
                .permissions(realNeedRequestPermission)
                .onExplainRequestReason((scope, deniedList) -> scope.showRequestReasonDialog(deniedList, perReqPermissionNotice, userConsent))
                .onForwardToSettings((scope, deniedList) -> scope.showForwardToSettingsDialog(deniedList, perReqPermissionNotice, userConsent))
                .request((allGranted, grantedList, deniedList) -> {
                    if (!allGranted) {
                        MUtil.show(getString(R.string.deny_permission) + deniedList);
                    } else {
                        MUtil.show(R.string.permission_consent);
                    }
                });
    }

    public List<String> getNeedRequestPermission(String... permissions) {
        List<String> needPermission = new ArrayList<>();
        for (String permission : permissions) {
            if (!PermissionX.isGranted(this, permission)) {
                needPermission.add(permission);
            }
        }
        return needPermission;
    }
}
