package com.puppy.uhfexample.presenter;

import com.puppy.uhfexample.base.BasePresenter;
import com.puppy.uhfexample.base.BaseView;
import com.puppy.uhfexample.bean.TagBankInfo;

import java.util.List;
import java.util.Map;

public interface InventoryContract {


    interface InventoryView extends BaseView {
        void setSpModeEnabled(boolean isEnabled);

        void setClearEnabled(boolean isEnabled);

        void setViewEnabled(boolean isEnabled);

        void clearData(String takeTime, String tagNumber, String readNumber);

        //Map<String, Integer> getDataMap();

        //void setDataMap(Map<String, Integer> dataMap);

        //void updateUI(final String epc, final String tid, final int readNumberss);

        void updateUI();

        void getInventoryRate(long readRate);

        void triggerKeyDown();
    }

    interface InventoryPresenter extends BasePresenter {
        void startInventory();

        void stopInventory();

        void clearDatas();

        boolean inventoryModeSet(int position, boolean ifsave);

        int inventoryModeGet();

        boolean inventoryTagBankSet(int position, boolean ifsave);

        int inventoryTagBankGet();

        long getPauseTime();

        long getUseTime();

        long getStartTime();

        String getTakeTime();

        String getTagNumber();

        String getReadNumber();

        void calculatingTime(long endTime);

        void postResult(String[] tagData);

        void postInventoryRate(long rate);

        List<String> getList();

        Map<String, TagBankInfo> getTagMap();

        void addInventoryDataGetListener();
    }


}
