package com.puppy.uhfexample.presenter;

import com.cyd.uhf.InventoryDataInfo;
import com.cyd.uhf.MConstant;
import com.cyd.uhf.TriggerKeyListener;

import com.puppy.uhf.UHFManager;
import com.puppy.uhfexample.base.BaseView;
import com.puppy.uhfexample.MyApp;

public class SearchImpl implements SearchContract.SearchPresenter, TriggerKeyListener, InventoryDataInfo {

    private SearchContract.SearchView mSearchView;

    private long currentMinute, oldMinute;

    public SearchImpl(BaseView mBaseView) {
        mSearchView = (SearchContract.SearchView) mBaseView;
        getUHFManager().addTriggerKeyListener(this);
    }

    @Override
    public void attachView(BaseView baseView) {

    }

    @Override
    public void detachView() {
        mSearchView = null;
        getUHFManager().removeTriggerKeyListener(this);
    }

    private UHFManager getUHFManager() {
        return MyApp.getMyApp().getUHFManager();
    }

    @Override
    public boolean setFilterData(int bank, int address, int length, String data, boolean save) {
        return getUHFManager().inventoryFilterData(bank, address, length, data, save);
    }

    @Override
    public boolean clearFilterData(byte bank, String data, boolean ifSaved) {
        return setFilterData(bank, 0, 0, data, ifSaved) && getUHFManager().frequencyModeSet(3) && getUHFManager().powerSet(33, ifSaved);
    }

    @Override
    public boolean frequency91520MHZRangSet(boolean ifSaved) {
        return getUHFManager().powerSet(25, ifSaved) && getUHFManager().frequenceRangeSet(new int[]{915250}, 1, ifSaved);
    }

    @Override
    public boolean startInventoryTag() {
        return getUHFManager().startInventoryTag();
    }

    @Override
    public boolean stopInventory() {
        return getUHFManager().stopInventory();
    }

    //音源播放
    @Override
    public void playSound(int val) {
        if (MyApp.ifOpenSound) {
            if (val > 30) {
                MyApp.getMyApp().playSound();
                oldMinute = System.currentTimeMillis();
            } else if (val > 20) {
                currentMinute = System.currentTimeMillis();
                if (currentMinute - oldMinute > 300) {
                    MyApp.getMyApp().playSound();
                    oldMinute = currentMinute;
                }
            } else if (val > 10) {
                currentMinute = System.currentTimeMillis();
                if (currentMinute - oldMinute > 600) {
                    MyApp.getMyApp().playSound();
                    oldMinute = currentMinute;
                }
            } else if (val > 0) {
                currentMinute = System.currentTimeMillis();
                if (currentMinute - oldMinute > 900) {
                    MyApp.getMyApp().playSound();
                    oldMinute = currentMinute;
                }
            }
        }
    }

    @Override
    public void addInventoryDataGetListener() {
        getUHFManager().inventoryDataGet(this);
    }

    @Override
    public void getTriggerKeyAction(int keyAction) {
        if (MConstant.TRIGGER_KEY_UP == keyAction) {
            if (!MyApp.ifInventoryOrScan) {
                mSearchView.triggerKeyDown();
            }
        }
    }

    @Override
    public void getInventoryData(String[] data) {
        mSearchView.getInvData(data);
    }
}
