package com.puppy.uhfexample.util;

import android.text.TextUtils;
import android.util.Log;
import android.widget.Toast;

import com.puppy.uhfexample.MyApp;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Objects;

/**
 * Created by cyd on 2018/6/4.
 */

public class MLog {
    public static boolean ifShown = true; //Enable Log
    //   private static boolean ifSave = false;//Save Log
    private static String TAG = "MLog";


    public static void setTAG(String TAG) {
        MLog.TAG = TAG;
    }

    public static void setTAG(Object cls) {
        if (cls != null)
            MLog.TAG = cls.getClass().getSimpleName();
    }

    public static String getTAG() {
        return TAG;
    }

    public static void e(String msg) {
        if (!ifShown)
            return;
        e(null, msg);
    }

    public static void e(String flag, String msg) {
        StackTraceElement targetStackTraceElement = getTargetStackTraceElement();
        if (TextUtils.isEmpty(flag)) {
            TAG = targetStackTraceElement.getMethodName();
        }
        Log.e(TAG, "(" + targetStackTraceElement.getFileName() + ":"
                + targetStackTraceElement.getLineNumber() + ") : " + msg);
    }


    public static void d(String msg) {
        if (!ifShown)
            return;
        StackTraceElement targetStackTraceElement = getTargetStackTraceElement();
        Log.d(TAG, "(" + targetStackTraceElement.getFileName() + ":"
                + targetStackTraceElement.getLineNumber() + ") : " + msg);

    }

    //循环打印javaBean的数据
    public static void e(Object o) {
        Class cls = Objects.requireNonNull(o).getClass();
        boolean flag = null != cls.getAnnotation(LogAnnotation.class);
        if (flag) {
            Method[] mds = cls.getDeclaredMethods();
            StringBuilder sb = new StringBuilder();
            try {
                for (Method md : mds) {
                    int modify = md.getModifiers();
                    String mdName = md.getName();
                    boolean hasReturnType = "void".equals(md.getReturnType().getSimpleName());
                    //有无参数暂时无法判断，需 api 26及以上才能使用
                    if (Modifier.isPublic(modify) && mdName.startsWith("get") && !hasReturnType) {
                        sb.append(mdName);
                        mdName = Objects.requireNonNull(md.invoke(o)).toString();
                        sb.append(" = ").append(mdName).append(" , ");
                    }
                }
                String log = sb.deleteCharAt(sb.lastIndexOf(",")).toString();
                if (!TextUtils.isEmpty(log)) e(log);
            } catch (IllegalAccessException | InvocationTargetException e) {
                e.printStackTrace();
            }
        }
    }

    private static StackTraceElement getTargetStackTraceElement() {
        StackTraceElement targetStackTrace = null;
        boolean shouldTrace = false;
        StackTraceElement[] stackTrace = Thread.currentThread().getStackTrace();
        for (StackTraceElement stackTraceElement : stackTrace) {
            boolean isLogMethod = stackTraceElement.getClassName().equals(MLog.class.getName());
            if (shouldTrace && !isLogMethod) {
                targetStackTrace = stackTraceElement;
                break;
            }
            shouldTrace = isLogMethod;
        }
        return targetStackTrace;
    }

    public static void shortToast(String string){
        Toast.makeText(MyApp.getMyApp(), string, Toast.LENGTH_SHORT).show();
    }

    public static void longToast(String string){
        Toast.makeText(MyApp.getMyApp(), string, Toast.LENGTH_LONG).show();
    }
}
