package com.puppy.uhfexample.util;

import android.view.View;

import com.puppy.uhfexample.base.BaseFragment;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentActivity;
import androidx.fragment.app.FragmentTransaction;

public class MyFragmentUtil {

    public static void addFragment(FragmentActivity activity, BaseFragment fragment, View view) {
        int containerId = view.getId();
        FragmentTransaction transaction = activity.getSupportFragmentManager().beginTransaction();
        transaction.replace(containerId, fragment);
        transaction.commit();
    }

    public static void addChildFragment(Fragment childFragment, BaseFragment fragment, View view) {
        int containerId = view.getId();
        FragmentTransaction transaction = childFragment.getChildFragmentManager().beginTransaction();
        transaction.replace(containerId, fragment);
        transaction.commit();
    }

    public static BaseFragment switchFragment(BaseFragment currentFragment, FragmentActivity activity,BaseFragment parentFragment, BaseFragment targetFragment, View view) {
        int containerId = view.getId();
        FragmentTransaction transaction;
        if (activity!=null){
            transaction = activity.getSupportFragmentManager().beginTransaction();
        }else {
            transaction = parentFragment.getChildFragmentManager().beginTransaction();
        }
        if (!targetFragment.isAdded()) {
            if (currentFragment != null) {
                transaction.hide(currentFragment);
            }
            transaction.add(containerId, targetFragment, targetFragment.getClass().getName());

        } else {
            transaction
                    .hide(currentFragment)
                    .show(targetFragment);
            targetFragment.showing();
        }
        currentFragment = targetFragment;
        transaction.commit();
        return currentFragment;
    }


}
