package com.puppy.uhfexample.view.customview;

import android.content.Context;
import android.content.res.TypedArray;
import android.util.AttributeSet;
import android.widget.RelativeLayout;
import android.widget.TextView;



import androidx.annotation.Nullable;
import androidx.annotation.StringRes;

import com.puppy.uhfexample.R;

public class TwoTextView extends RelativeLayout {

    private TextView right_tv;

    public TwoTextView(Context context) {
        this(context, null);
    }

    public TwoTextView(Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public TwoTextView(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        TypedArray ta = context.obtainStyledAttributes(attrs, R.styleable.TwoTextView);
        String leftText = ta.getString(R.styleable.TwoTextView_leftText);
        String rightText = ta.getString(R.styleable.TwoTextView_rightText);
        ta.recycle();
        initView(leftText, rightText);
    }

    private void initView(String leftText, String rightText) {
        Context context = getContext();
        setBackgroundResource(R.color.GhostWhite);
        TextView left_tv = new TextView(context);
        left_tv.setText(leftText);
        right_tv = new TextView(context);
        right_tv.setText(rightText);
        addView(left_tv);
        addView(right_tv);
        RelativeLayout.LayoutParams rParams = (LayoutParams) left_tv.getLayoutParams();
        rParams.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
        left_tv.setLayoutParams(rParams);
        rParams = (LayoutParams) right_tv.getLayoutParams();
        rParams.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);
        right_tv.setLayoutParams(rParams);
    }

    public void setText(@StringRes int rid) {
        right_tv.setText(rid);
    }

    public void setText(String text) {
        right_tv.setText(text);
    }
}
