package com.puppy.uhfexample.view.fragment;

import android.view.View;


import com.puppy.uhfexample.R;
import com.puppy.uhfexample.base.BaseFragment;
import com.puppy.uhfexample.MyApp;

import com.puppy.uhfexample.databinding.FragmentDestoryBinding;
import com.puppy.uhfexample.presenter.DestoryContract;
import com.puppy.uhfexample.presenter.DestroyImpl;
import com.puppy.uhfexample.util.MLog;

import static android.text.TextUtils.isEmpty;


public class DestroyFragment extends BaseFragment<DestroyImpl, FragmentDestoryBinding> implements DestoryContract.DestoryView, View.OnClickListener {
    @Override
    public int getLayoutId() {
        return R.layout.fragment_destory;
    }

    @Override
    public void init(View view) {
        binding.etDestroyFilterData.setText("1234567890ABCDEF12345678");
        binding.etDestroyPassword.setText("00000000");
        binding.etDestroyFilterAddress.setText("32");
        binding.etDestroyFilterLength.setText("96");
        binding.btDestroyTag.setOnClickListener(this);
    }

    @Override
    public void updateFilterData(String data, boolean dataBank) {
        super.updateFilterData(data, dataBank);
        binding.etDestroyFilterData.setText(data);
        binding.spDestroyFilterStorage.setSelection(dataBank ? 0 : 1);
        binding.etDestroyFilterAddress.setText(dataBank ? "32" : "0");
        binding.etDestroyFilterLength.setText("96");
    }

    @Override
    protected DestroyImpl getPresenter() {
        return new DestroyImpl(this);
    }

    @Override
    public void onClick(View v) {
        if (ifNotNull()) {
            int address = Integer.parseInt(binding.etDestroyFilterAddress.getText().toString());
            int length = Integer.parseInt(binding.etDestroyFilterLength.getText().toString());
            int value = binding.spDestroyFilterStorage.getSelectedItemPosition();
            String pwd = binding.etDestroyPassword.getText().toString();
            String data = binding.etDestroyFilterData.getText().toString();
            MLog.e("销毁参数：\naddress=" + address + "length\n" + length + "\nvalue=" + value + "\npwd=" + pwd + "\ndata=" + data);
            boolean status = presenter.killTag(pwd, MyApp.UHF[value], address, length, data);
            MLog.e("status=" + status);
            int result = status ? R.string.kill_tag_success : R.string.kill_tag_failed;
            MLog.shortToast(getString(result));
        } else {
            MLog.shortToast(getString(R.string.data_cannot_be_null));
        }
    }

    //如果EditText的数据都不为空
    private boolean ifNotNull() {
        return !isEmpty(binding.etDestroyFilterData.getText()) && !isEmpty(binding.etDestroyFilterAddress.getText())
                && !isEmpty(binding.etDestroyFilterLength.getText()) && !isEmpty(binding.etDestroyPassword.getText());
    }

}
