package com.puppy.uhfexample.view.fragment;

import android.view.View;


import com.puppy.uhfexample.R;
import com.puppy.uhfexample.base.BaseFragment;
import com.puppy.uhfexample.MyApp;

import com.puppy.uhfexample.databinding.FragmentLockBinding;
import com.puppy.uhfexample.presenter.LockContract;
import com.puppy.uhfexample.presenter.LockImpl;
import com.puppy.uhfexample.util.MLog;

import static android.text.TextUtils.isEmpty;

public class LockFragment extends BaseFragment<LockImpl, FragmentLockBinding> implements LockContract.LockView, View.OnClickListener {

    @Override
    public int getLayoutId() {
        return R.layout.fragment_lock;
    }

    @Override
    public void init(View view) {
        binding.btLockTag.setOnClickListener(this);
        binding.btUnlockTag.setOnClickListener(this);

        binding.etLockAccessPassword.setText("00000000");
        binding.etLockFilterAddress.setText("32");
        binding.etLockFilterLength.setText("96");
        binding.etLockFilterData.setText("1234567890ABCDEF12345678");

    }

    @Override
    public void updateFilterData(String data, boolean dataBank) {
        super.updateFilterData(data, dataBank);
        binding.etLockFilterData.setText(data);
        binding.spLockFilterStorage.setSelection(dataBank ? 0 : 1);
        binding.etLockFilterAddress.setText(dataBank ? "32" : "0");
        binding.etLockFilterLength.setText("96");
    }


    @Override
    protected LockImpl getPresenter() {
        return new LockImpl(this);
    }

    @Override
    public void onClick(View v) {
        String pwd = binding.etLockAccessPassword.getText().toString();
        int address = Integer.parseInt(binding.etLockFilterAddress.getText().toString());
        int length = Integer.parseInt(binding.etLockFilterLength.getText().toString());
        String data = binding.etLockFilterData.getText().toString();
        int lockitem = binding.spLockOperateStorage.getSelectedItemPosition() + 1;
        int val = binding.spLockFilterStorage.getSelectedItemPosition();
        MLog.e("传入参数：" + pwd + " " + MyApp.UHF[val] + " " + address + " " + length + " " + data + " " + lockitem);
        switch (v.getId()) {
            case R.id.bt_lock_tag:
                locked(true);
//                lock(pwd, MyApp.UHF[val], address, length, data, lockitem);
                break;
            case R.id.bt_unlock_tag:
                locked(false);
//                unlock(pwd, MyApp.UHF[val], address, length, data, lockitem);
                break;
            default:
                break;
        }
    }

    private void locked(boolean flag) {
        if (ifNotNull()) {
            String pwd = binding.etLockAccessPassword.getText().toString();
            int address = Integer.parseInt(binding.etLockFilterAddress.getText().toString());
            int length = Integer.parseInt(binding.etLockFilterLength.getText().toString());
            String data = binding.etLockFilterData.getText().toString();
            int lockItem = binding.spLockOperateStorage.getSelectedItemPosition();
            int val = binding.spLockFilterStorage.getSelectedItemPosition();
            boolean status = false;
            if (flag) {
                MLog.e("传入参数2：" + pwd + " " + MyApp.UHF[val] + " " + address + " " + length + " " + data + " " + lockItem);
                status = presenter.lockMen(pwd, MyApp.UHF[val], address, length, data, lockItem, 0);
                MLog.e("锁定标签：" + status);
            } else {
                MLog.e("传入参数3：" + pwd + " " + MyApp.UHF[val] + " " + address + " " + length + " " + data + " " + lockItem);
                status = presenter.unlockMen(pwd, MyApp.UHF[val], address, length, data, lockItem, 0);
                MLog.e("解锁标签：" + status);
            }
            int stringId = status ? (flag ? R.string.lock_success : R.string.unlock_success) : (flag ? R.string.lock_failed : R.string.unlock_failed);
            MLog.shortToast(getString(stringId));
        } else {
            MLog.shortToast(getString(R.string.data_cannot_be_null));
        }
    }

    private void lock(String pwd, int val, int address, int length, String data, int lockitem) {
        if (ifNotNull()) {
            boolean status = presenter.lockMen(pwd, MyApp.UHF[val], address, length, data, lockitem, 0);
            int stringId = status ? R.string.lock_success : R.string.lock_failed;
            MLog.shortToast(getString(stringId));
            MLog.e("锁定标签：" + status);
        } else {
            MLog.shortToast(getString(R.string.data_cannot_be_null));
        }
    }

    private void unlock(String pwd, int val, int address, int length, String data, int lockitem) {
        if (ifNotNull()) {
            boolean status = presenter.unlockMen(pwd, MyApp.UHF[val], address, length, data, lockitem, 0);
            int stringId = status ? R.string.unlock_success : R.string.unlock_failed;
            MLog.shortToast(getString(stringId));
            MLog.e("解锁标签：" + status);
        } else {
            MLog.shortToast(getString(R.string.data_cannot_be_null));
        }
    }

    private boolean ifNotNull() {
        return !isEmpty(binding.etLockFilterAddress.getText()) && !isEmpty(binding.etLockFilterLength.getText())
                && !isEmpty(binding.etLockFilterData.getText()) && !isEmpty(binding.etLockAccessPassword.getText());
    }

    @Override
    public void onDestroyView() {
        presenter.detachView();
        super.onDestroyView();
    }

}
