package com.puppy.uhfexample.view.fragment;

import android.os.Bundle;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.RadioGroup;


import com.puppy.uhfexample.R;
import com.puppy.uhfexample.base.BaseFragment;

import com.puppy.uhfexample.databinding.FragmentSettingsBinding;
import com.puppy.uhfexample.presenter.SettingContract;
import com.puppy.uhfexample.presenter.SettingImpl;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import static com.puppy.uhfexample.util.MyFragmentUtil.switchFragment;

public class SettingFragment extends BaseFragment<SettingContract.SettingPresenter, FragmentSettingsBinding> implements RadioGroup.OnCheckedChangeListener, SettingContract.SettingView {

    private BaseFragment currentFragment;

    private RadioGroup mSettingsRg;
    private FrameLayout mContainerSettings;

    @Override
    public int getLayoutId() {
        return R.layout.fragment_settings;
    }

    @Override
    public void init(View view) {
        mSettingsRg = view.findViewById(R.id.rg_settings);
        mSettingsRg.setOnCheckedChangeListener(this);
        mContainerSettings = view.findViewById(R.id.settings_container);
    }

    @Override
    protected SettingContract.SettingPresenter getPresenter() {
        return new SettingImpl(this);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        int checkedId = mSettingsRg.getCheckedRadioButtonId();
        for (int i = 0; i < mSettingsRg.getChildCount(); i++) {
            if (mSettingsRg.getChildAt(i).getId() == checkedId) {
                currentFragment = switchFragment(currentFragment, null, this, myApp.getSettingsFragmentsList().get(i), mContainerSettings);
                return;
            }
        }
    }

    @Override
    public void onHiddenChanged(boolean hidden) {
        super.onHiddenChanged(hidden);
        if (!hidden) {
            if (currentFragment != null) {
                currentFragment.showing();
            }
        }
    }

    @Override
    public void onCheckedChanged(RadioGroup radioGroup, int checkedId) {
        if (radioGroup != null) {
            for (int i = 0; i < radioGroup.getChildCount(); i++) {
                if (radioGroup.getChildAt(i).getId() == checkedId) {
                    currentFragment = switchFragment(currentFragment, null, this, myApp.getSettingsFragmentsList().get(i), mContainerSettings);
                    return;
                }
            }
        }
    }


}
