package com.puppy.uhfexample.view.fragment;

import android.os.Bundle;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.RadioGroup;


import com.puppy.uhfexample.R;
import com.puppy.uhfexample.base.BaseFragment;

import com.puppy.uhfexample.databinding.FragmentTagOperateBinding;
import com.puppy.uhfexample.presenter.TagOperateContract;
import com.puppy.uhfexample.presenter.TagOperateImpl;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import static com.puppy.uhfexample.util.MyFragmentUtil.switchFragment;


public class TagOperateFragment extends BaseFragment<TagOperateContract.TagOperatePresenter, FragmentTagOperateBinding> implements RadioGroup.OnCheckedChangeListener, TagOperateContract.TagOperateView {

    private BaseFragment currentFragment;

    private RadioGroup mWriteReadRg;
    private FrameLayout mContainerFragment;

    @Override
    public int getLayoutId() {
        return R.layout.fragment_tag_operate;
    }


    @Override
    public void init(View view) {
        mWriteReadRg = (RadioGroup) view.findViewById(R.id.rg_write_read);
        mContainerFragment = (FrameLayout) view.findViewById(R.id.fragment_container);
        mWriteReadRg.setOnCheckedChangeListener(this);

    }

    @Override
    protected TagOperateContract.TagOperatePresenter getPresenter() {
        return new TagOperateImpl(this);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        int checkedId = mWriteReadRg.getCheckedRadioButtonId();
        for (int i = 0; i < mWriteReadRg.getChildCount(); i++) {
            if (mWriteReadRg.getChildAt(i).getId() == checkedId) {
                currentFragment = switchFragment(currentFragment, null, this, myApp.getTagsFragmentsList().get(i), mContainerFragment);
            }
        }
    }

    @Override
    public void onResume() {
        super.onResume();

    }

    @Override
    public void onCheckedChanged(RadioGroup radioGroup, int checkedId) {
        if (radioGroup != null) {
            for (int i = 0; i < radioGroup.getChildCount(); i++) {
                if (radioGroup.getChildAt(i).getId() == checkedId) {
                    currentFragment = switchFragment(currentFragment, null, this, myApp.getTagsFragmentsList().get(i), mContainerFragment);
                    return;
                }
            }
        }
    }


}
